package terremoti_con_vettori;

public class EventoSismico{
	
	public static enum Regione{ABRUZZO,BASILICATA,CALABRIA,CAMPANIA,EMILIAROMAGNA,FRIULIVENEZIAGIULIA,LIGURIA,LAZIO,LOMBARDIA,MARCHE,MOLISE,PIEMONTE,PUGLIA,SARDEGNA,SICILIA,TOSCANA,TRENTINOALTOADIGE,UMBRIA,VALLEDAOSTA,VENETO};
	
	protected static final double SOGLIA_FORTE = 6.0;
	
	private static int progressivo=0;
	
	protected String codice;
	protected String data;
	protected Regione regione;
	protected double latitudine;
	protected double longitudine;
	protected double profondita;
	protected double magnitudo;
	
	public EventoSismico(){
		this("gg/mm/aaaa",null,0,0,0,0);	
	}
	
	public EventoSismico(String data, Regione regione, double lat, double lon, double prof, double magnitudo){
		String giorno = data.substring(0,data.indexOf("/"));
		String mese = data.substring(data.indexOf("/")+1,data.lastIndexOf("/"));
		String anno = data.substring(data.lastIndexOf("/")+1);
		this.codice = "#"+(++progressivo)+"-"+anno+"-"+mese+"-"+giorno;
		this.data = data;
		this.regione = regione;
		this.latitudine = lat;
		this.longitudine = lon;
		this.profondita = prof;
		this.magnitudo = magnitudo;
	}
	
	// punto 1)
	public boolean terremotoForte(){
		return magnitudo >= SOGLIA_FORTE;
	}
	
	public String getCodice(){
		return codice;
	}
	
	public String getData(){
		return data;
	}
	
	public Regione getRegione() {
		return regione;
	}
	
	public String toString(){
		String s = "";
		s += "Codice: "+codice+"\n";
		s += "Data: "+data+"\n";
		s += "Regione: "+regione+"\n";
		s += "Latitudine: "+latitudine+"\n";
		s += "Longitudine: "+longitudine+"\n";
		s += "Profondit: "+profondita+"\n";
		s += "Magnitudo: "+magnitudo+"\n\n";
		return s;
	}
	
	// metodo di utilita'
	public int getAnno(){
		return Integer.parseInt(data.substring(data.lastIndexOf("/")+1));
	}
	
}
