package terremoti_con_vettori;

import terremoti_con_vettori.EventoSismico.Regione;

public class INGV {

	private static final int MAX_EVENTI = 1000;
	
	private EventoSismico[] eventi;
	private int numEventi;
	
	public INGV() {
		this(new EventoSismico[MAX_EVENTI], 0);
	}
	
	public INGV(EventoSismico[] eventi, int numE) {
		this.eventi = eventi;
		this.numEventi = numE;
	}
	
	// punto 2)
	public EventoSismico trovaTerremoto(String codice){
		EventoSismico evento = null;
		boolean trovato=false;
		for(int i=0; i<numEventi && !trovato; i++)
			if(eventi[i].getCodice().equals(codice)){
				trovato = true;
				evento = eventi[i];
			}
		return evento;
	}
	
	// punto 3)
	public EventoSismico[] terremotiFortiInRegione(Regione regione){
		EventoSismico[] eventiForti;
		// determiniamo il numero di terremoti forti in regione per poter dimensionare il vettore da restituire
		int numFortiInRegione = 0;
		for(int i=0; i<numEventi; i++)
			if(eventi[i].terremotoForte() && eventi[i].getRegione()==regione)
				numFortiInRegione++;
		// creiamo il vettore con la dimensione determinata
		eventiForti = new EventoSismico[numFortiInRegione];
		int j=0; // indice di scorrimento nel vettore da restituire
		// trasferiamo i terremoti forti nel vettore da restituire
		for(int i=0; i<numEventi; i++)
			if(eventi[i].terremotoForte() && eventi[i].getRegione()==regione)
				eventiForti[j++] = eventi[i]; 
		return eventiForti;
	}
	
	// punto 4)
	public int numTsunamiViolentiPerAnno(int anno){
		int numT = 0;
		for(int i=0; i<numEventi; i++)
			if(eventi[i] instanceof EventoTsunami)
				if(eventi[i].getAnno() == anno && ((EventoTsunami)eventi[i]).tsunamiViolento())
					numT++;
		return numT;
	}
	
	
}
